const sharp = require("sharp");
const path = require("path");
const fsp = require("fs/promises");
const fs = require("fs");

console.log("Processing images in raw-images....");

//Input & Output folders
const rawImageRoot = path.join(__dirname, "raw-images");
const optImageRoot = path.join(__dirname, "assets", "images", "optimized");

//Clean output image folder
fs.rmSync(optImageRoot, { recursive: true, force: true });
fs.mkdirSync(optImageRoot);

//Get the file name (without extension) from a path
function fname(p) {
    return path.basename(p, path.extname(p));
}

async function getImageFiles(...imageFolder) {
    const parent = path.join(rawImageRoot, ...imageFolder);

    //Make a corresponding output folder
    fs.mkdirSync(path.join(optImageRoot, ...imageFolder));

    //Get all files (not directories) in this folder
    const paths = await fsp.readdir(parent);
    const files = [];
    await Promise.all(
        paths.map(async p => {
            const fullPath = path.join(parent, p);
            if ((await fsp.stat(fullPath)).isDirectory()) return;
            files.push(path.join(...imageFolder, p));
        })
    );

    return files;
}

(async function () {
    const files = {
        graphics: await getImageFiles("graphics"),
        stations: await getImageFiles("stations"),
        trains: await getImageFiles("trains")
    };

    const finalPaths = {};

    await Promise.all(Object.keys(files).map(section => {
        finalPaths[section] = [];
        return files[section].map(async p => {
            //Full source path
            const rawFullPath = path.join(rawImageRoot, p);

            //Full path + name (without extension)
            const optFullName = path.join(path.dirname(path.join(optImageRoot, p)), fname(p).replaceAll(" ", "_"));
        
            //Process images
            let finalFullPath;
            switch (section) {
                case "graphics": {
                    finalFullPath = optFullName + ".png";
                    sharp(rawFullPath).toFile(finalFullPath);
                    break;
                }
                case "stations": {
                    finalFullPath = optFullName + ".jpg";
                    sharp(rawFullPath).resize(800, 300, { fit: "cover", withoutEnlargement: true }).jpeg({ mozjpeg: true }).toFile(finalFullPath);
                    break;
                }
                case "trains": {
                    finalFullPath = optFullName + ".png";
                    sharp(rawFullPath).resize(800, 300, { fit: "inside", withoutEnlargement: true }).png().toFile(finalFullPath);
                    break;
                }
                default: {
                    throw new Error("Unhandled image section " + section);
                }
            }

            finalPaths[section].push(finalFullPath);
        })
    }).flat());

    //Write JS files
    await Promise.all(
        Object.keys(finalPaths).map(async section => {
            await fsp.writeFile(path.join(optImageRoot, section, "index.js"), [
                "//DO NOT EDIT THIS FILE MANUALLY",
                "//This file was autogenerated by process-images.js",
                "//To update optimized images, please run `yarn run images`",
                "module.exports = {",
                ...finalPaths[section].map(p => `    "${fname(p)}": require("./${path.basename(p)}"),`),
                "}"
            ].join("\n"));
        })
    )
})();